import { Factory, MaybeFactory } from '../utils/types';
import { BaseService } from './base-service';
export declare type InferModuleID<T extends ServiceModule> = T extends ServiceModule<infer U> ? U : never;
export declare abstract class ServiceModule<TID extends string = string> {
    abstract id: TID;
    abstract registerService(service: BaseService): void;
}
export declare class ServiceModuleRegistry {
    _factories: {
        [moduleId: string]: Factory<ServiceModule>;
    };
    _modules: {
        [moduleId: string]: ServiceModule;
    };
    add(id: string, factory: MaybeFactory<ServiceModule>): void;
    resolve<T extends ServiceModule>(id: InferModuleID<T>): Promise<T | undefined>;
}
//# sourceMappingURL=service-module-registry.d.ts.map