import { BaseService } from '../../core';
import { ServiceModule } from '../../core/service-module-registry';
import { CronInvoker } from './invoker';
import { CronSessionStorage } from './storage';
export declare const ModuleId = "cron";
export interface ModuleOptions {
    storage?: CronSessionStorage;
    invoker: CronInvoker;
}
export declare type CronHandler = (prevTime: number, time: number) => Promise<void>;
export declare class Module extends ServiceModule<'cron'> {
    id: "cron";
    private readonly storage;
    private services;
    constructor(options: ModuleOptions);
    registerService(service: BaseService<any>): void;
    invoke(): void;
}
//# sourceMappingURL=module.d.ts.map